`ifndef VERILATOR
module testbench;
  reg [4095:0] vcdfile;
  reg clock;
`else
module testbench(input clock, output reg genclock);
  initial genclock = 1;
`endif
  reg genclock = 1;
  reg [31:0] cycle = 0;
  reg [0:0] PI_i_start_signal;
  reg [0:0] PI_i_clk;
  pastassert UUT (
    .i_start_signal(PI_i_start_signal),
    .i_clk(PI_i_clk)
  );
`ifndef VERILATOR
  initial begin
    if ($value$plusargs("vcd=%s", vcdfile)) begin
      $dumpfile(vcdfile);
      $dumpvars(0, testbench);
    end
    #5 clock = 0;
    while (genclock) begin
      #5 clock = 0;
      #5 clock = 1;
    end
  end
`endif
  initial begin
`ifndef VERILATOR
    #1;
`endif
    // UUT.$auto$verificsva.cc:1794:import$42 = 1'b0;
    // UUT.$auto$verificsva.cc:1795:import$43 = 1'b0;
    // UUT.$verific$n85$10 = 1'b1;
    UUT.counter = 16'b0000000000000000;

    // state 0
    PI_i_start_signal = 1'b0;
    PI_i_clk = 1'b0;
  end
  always @(posedge clock) begin
    // state 1
    if (cycle == 0) begin
      PI_i_start_signal <= 1'b0;
      PI_i_clk <= 1'b0;
    end

    genclock <= cycle < 1;
    cycle <= cycle + 1;
  end
endmodule
